<?php
/*
Plugin Name: mypolls
Version: 2.0.5
Description: Plugin pour faire des sondages sur sa gallerie / Plugin to carry out surveys on its gallery 
Plugin URI: http://phpwebgallery.net/ext/extension_view.php?eid=181
*/

/*
--------------------------------------------------------------------------------
  Author     : Grum
    email    : grum@grum.dnsalias.com
    website  : http://photos.grum.dnsalias.com
    PWG user : http://forum.phpwebgallery.net/profile.php?id=3706

    << May the Little SpaceFrog be with you ! >>
--------------------------------------------------------------------------------

:: HISTORY
  2.0.0-beta  - 04/11/07  +refonte complte du plugin
  2.0.1-beta  - 10/11/07  +conservation & rcupration des sondages de la version 1.x
                          -correction de messages d'erreurs js
                          -couleur du graphique d'un sondage correspond  la couleur affecte
                          -bloque l'activation d'un sondage si une traduction n'est faite qu'en partie
                          -procdure d'export (fichier SQL) automatique lors de la dsinstallation
                          -usage du plugin GRUM_PLUGIN_CORE
  2.0.2       - 02/01/08  - correction template (ajax) pour tre compatible avec IE7.0
                          - remplacement des "&" dans les URL par des "&amp;" pour tre aux normes
  2.0.3       - 06/01/08  - correction insertions avec MySQL 5  
  2.0.4       - 06/01/08  - correction insertions&maj
                          - correction pb sur affichage de mypolls_action_ok
  2.0.5       - 25/05/08  - adaption du plugin suite  modification de la gestion
                            de google translator (cf. grum_plugin_classes v1.2.0)
:: TO DO

--------------------------------------------------------------------------------
*/

// pour faciliter le debug :o)
// ini_set('error_reporting', E_ALL);
 //ini_set('display_errors', true);

if(!defined('PHPWG_ROOT_PATH')) die('Hacking attempt!');

global $prefixeTable, $user, $lang;

define('MYPOLLS_DIR' , basename(dirname(__FILE__)));
define('MYPOLLS_PATH' , PHPWG_PLUGINS_PATH . MYPOLLS_DIR . '/');

define('MYPOLLS_VERSION' , '2.0.5');

if(basename($_SERVER["PHP_SELF"])=='admin.php')
{
  $user['language']='';
  include_once("plugin_class_bo.inc.php");
  $obj=new bo_mypolls($prefixeTable, __FILE__);
  /*
    can't put this function here because $user not defined, and if $user not define,
    it's not possible to check user's admin possibilities (is_adviser()) and user's
    language
    so function is called in the plugin_admin.php file
    $obj->return_ajax_content(); //if is ajax content, don't need to do all....
  */
  $obj->init_events();
}
else
{
  $user['language']='';
  include_once("plugin_class_fo.inc.php");
  $obj=new fo_mypolls($prefixeTable, __FILE__);
  /*
    ajax function putted here because don't need to know user's possibilities
    (no functions allowing to modify database)
    calling this function here allow to die script and return immediately data
    without doing everything (making pwg page)
  */
  $obj->return_ajax_content(); //if is ajax content, don't need to do all stuff....
  $obj->init_events();
}

set_plugin_data($plugin['id'], $obj)

?>
